//     Copyright 1998--2010 Michael Bruce-Lockhart and Theodore S. Norvell
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License. 
// You may obtain a copy of the License at 
//
//     http://www.apache.org/licenses/LICENSE-2.0 
//
// Unless required by applicable law or agreed to in writing, 
// software distributed under the License is distributed on an 
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
// either express or implied. See the License for the specific language 
// governing permissions and limitations under the License.

package tm.clc.analysis;

/** <p>Represents a definition from the perspective of name resolution.
 * Can represent any type of definition (namespace, function, type,
 * variable).</p>
 * <p>See {@link SymbolTableDesign.html#Definition Symbol Table Design} for a more
 * detailed discussion.</p>
 * <p><B>Known Implementations</B></p>
 * <ol><li>implemented by {@link Declaration}</li>
 * <li>implemented by {@link ScopeHolder}</li></ol>
 * @created Aug 13 2001
 * @author Derek Reilly
 * @version 0
 */

public interface Definition {

}