//     Copyright 1998--2010 Michael Bruce-Lockhart and Theodore S. Norvell
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License. 
// You may obtain a copy of the License at 
//
//     http://www.apache.org/licenses/LICENSE-2.0 
//
// Unless required by applicable law or agreed to in writing, 
// software distributed under the License is distributed on an 
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
// either express or implied. See the License for the specific language 
// governing permissions and limitations under the License.

/*
	Input Frame
*/

package tm.evaluator;

import java.awt.*;

import tm.interfaces.ExternalCommandInterface;

public class InputFrame extends Frame
{
	public InputFrame( Evaluator evaluator )
	{
		super("Input request");
		
		this.evaluator = evaluator ;

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		setLayout(null);
		setSize(433,197);
		setVisible(false);
		label1.setText("Keyboard input required");
		add(label1);
		label1.setBounds(48,24,233,34);
		button1.setLabel("End of line (Enter)");
		add(button1);
		button1.setBackground(java.awt.Color.lightGray);
		button1.setBounds(264,72,132,30);
		button2.setLabel("End of File");
		add(button2);
		button2.setBackground(java.awt.Color.lightGray);
		button2.setBounds(108,120,72,30);
		add(textField1);
		textField1.setBounds(48,72,209,20);

		SymAction lSymAction = new SymAction();
		button1.addActionListener(lSymAction);
		button2.addActionListener(lSymAction);
		textField1.addActionListener(lSymAction) ;
		//}}
		this.setVisible(true) ;
		textField1.requestFocus() ;
}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	//public synchronized void show()
	//{
	//	Rectangle bounds = getParent().bounds();
	//	Rectangle abounds = bounds();
    //
	//	move(bounds.x + (bounds.width - abounds.width)/ 2,
	//		 bounds.y + (bounds.height - abounds.height)/2);
    //
	// 	super.show();
	//}

    Evaluator evaluator ; // Where to send the strings.
    
	//{{DECLARE_CONTROLS
	java.awt.Label label1 = new java.awt.Label();
	java.awt.Button button1 = new java.awt.Button();
	java.awt.Button button2 = new java.awt.Button();
	java.awt.TextField textField1 = new java.awt.TextField(15);
	//}}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == button1)
				button1_Action(event);
			else if (object == button2)
				button2_Action(event);
			else if (object == textField1)
				button1_Action(event);
		}
	}

	void button1_Action(java.awt.event.ActionEvent event)
	{
	    String text = textField1.getText() + "\n" ;
	    evaluator.addInputString( text ) ;
	    setVisible( false ) ;
		dispose() ;
	}

	void button2_Action(java.awt.event.ActionEvent event)
	{
	    String text = textField1.getText() + "\0" ;
        evaluator.addInputString( text ) ;
	    setVisible( false ) ;
		dispose() ;
	}
	//{{DECLARE_MENUS
	//}}
}